#include <iostream>
using namespace std;
int main()
{
    int n,k;
    cin >> n;
    cin >> k;
    int mat[n][n],temp[n][n];
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
            cin >> mat[i][j];
    int brojac=0;
    for(int b=1;b<=k;b++)
    {
        int poci,pocj,kraji=0,krajj=0;
        bool dobar=false;
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<n;j++)
            {
                if(mat[i][j]==b)
                {
                    if(!dobar)
                    {
                        dobar=true;
                        poci=i;
                        pocj=j;
                    }
                    if(kraji<i)
                        kraji=i;
                    if(krajj<j)
                        krajj=j;
                }
            }
        }
        if(!dobar)
            continue;
        dobar=true;
        for(int i=poci;i<=kraji;i++)
        {
            for(int j=pocj;j<=krajj;j++)
            {
                if(mat[i][j]!=b)
                {
                    dobar=false;
                    break;
                }
            }
            if(!dobar)
                break;
        }
        if(dobar)
            brojac++;
    }
    cout << brojac;
    return 0;
}